<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qbs.qdoc -->
  <title>Appendix A: Building Qbs | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Appendix A: Building Qbs</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="reference.html" />
  <link rel="next" href="porting-to-qbs.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="reference.html">Reference</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="porting-to-qbs.html">Appendix B: Migrating from Other Build Systems</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#supported-platforms">Supported Platforms</a></li>
<li class="level1"><a href="#system-requirements">System Requirements</a></li>
<li class="level2"><a href="#documentation">Documentation</a></li>
<li class="level1"><a href="#building-qbs-with-qmake">Building Qbs with QMake</a></li>
<li class="level2"><a href="#qmake-configure-options">QMake Configure Options</a></li>
<li class="level1"><a href="#building-qbs-with-qbs">Building Qbs with Qbs</a></li>
<li class="level2"><a href="#qbs-build-options">Qbs Build Options</a></li>
<li class="level1"><a href="#using-docker">Using Docker</a></li>
<li class="level2"><a href="#linux-containers">Linux Containers</a></li>
<li class="level2"><a href="#windows-containers">Windows Containers</a></li>
<li class="level2"><a href="#building-release-packages">Building Release Packages</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Appendix A: Building Qbs</h1>
<span class="subtitle"></span>
<!-- $$$building-qbs.html-description -->
<div class="descr"> <a name="details"></a>
<p>Qbs can be <a href="installing.html">installed from binary packages</a> or built from sources, as described in this appendix. In addition, this appendix describes how to use Docker images for developing Qbs.</p>
<a name="supported-platforms"></a>
<h2 id="supported-platforms">Supported Platforms</h2>
<p>Qbs can be installed and run on the following platforms:</p>
<ul>
<li>Windows 7, or later</li>
<li>Linux (tested on Debian 8 and 9, Ubuntu 16.04, OpenSuSE 13.2, and Arch Linux)</li>
<li><a href="nolink">macOS</a> 10.7, or later</li>
</ul>
<a name="system-requirements"></a>
<h2 id="system-requirements">System Requirements</h2>
<p>To build Qbs from the source, you need:</p>
<ul>
<li>Qt 5.11, or later</li>
<li>Windows: MinGW with GCC 4.9 or Microsoft Visual Studio 2015, or later</li>
<li>Linux: GCC 4.9, or later, or Clang 3.9&#x2e;0, or later</li>
<li><a href="nolink">macOS</a>: Xcode 6.2, or later</li>
</ul>
<p>An installed toolchain has to match the one that Qt was compiled with.</p>
<a name="documentation"></a>
<h3 id="documentation">Documentation</h3>
<p>Building the Qbs documentation requires Python 2.7 or 3.2 or above, as well as some third party Python modules. These can be installed via <code>pip</code>:</p>
<pre class="cpp">

  pip install beautifulsoup4 lxml

</pre>
<p>Regenerating the man page requires the <code>help2man</code> tool.</p>
<a name="building-qbs-with-qmake"></a>
<h2 id="building-qbs-with-qmake">Building Qbs with QMake</h2>
<p>To build Qbs, enter the following command:</p>
<pre class="cpp">

  qmake <span class="operator">-</span>r qbs<span class="operator">.</span>pro <span class="operator">&amp;</span><span class="operator">&amp;</span> make

</pre>
<p>Depending on your platform, you might use <code>mingw32-make</code>, <code>nmake</code>, or <code>jom</code> instead of <code>make</code>.</p>
<p>Installation by using <code>make install</code> is usually not needed. It is however possible, by entering the following command.</p>
<pre class="cpp">

  make install INSTALL_ROOT<span class="operator">=</span>$INSTALL_DIRECTORY

</pre>
<a name="qmake-configure-options"></a>
<h3 id="qmake-configure-options">QMake Configure Options</h3>
<p>Qbs recognizes the following qmake CONFIG options to customize the build:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Option</th><th >Notes</th></tr></thead>
<tr valign="top" class="odd"><td >qbs_enable_unit_tests</td><td >Enable additional autotests.</td></tr>
<tr valign="top" class="even"><td >qbs_disable_rpath</td><td >Disable the use of rpath. This can be used when packaging Qbs for distributions which do not permit the use of rpath, such as Fedora.</td></tr>
<tr valign="top" class="odd"><td >qbs_no_dev_install</td><td >Exclude header files from installation, that is, perform a non-developer build.</td></tr>
<tr valign="top" class="even"><td >qbs_no_man_install</td><td >Exclude the man page from installation.</td></tr>
<tr valign="top" class="odd"><td >qbs_enable_project_file_updates</td><td >Enable API for updating project files. This implies a dependency to the Qt GUI module.</td></tr>
<tr valign="top" class="even"><td >qbs_use_bundled_qtscript</td><td >Use the bundled QtScript library.</td></tr>
</table></div>
<p>In addition, you can set the <code>QBS_SYSTEM_SETTINGS_DIR</code> environment variable before running qmake to specify a custom location for Qbs to look for its system-level settings.</p>
<a name="building-qbs-with-qbs"></a>
<h2 id="building-qbs-with-qbs">Building Qbs with Qbs</h2>
<p>It is also possible to build Qbs with the previously installed Qbs version. To build Qbs, enter the following command in the source directory:</p>
<pre class="cpp">

  qbs

</pre>
<p>This will use the <code>defaultProfile</code> or pick up the Qt version and the toolchain from the <code>PATH</code> if the <code>defaultProfile</code> is not set. See <a href="configuring.html">Configuring Profiles and Preferences</a> for details about profiles.</p>
<p>To run automatic tests, the <code>autotest-runner</code> product should be built:</p>
<pre class="cpp">

  qbs build <span class="operator">-</span>p autotest<span class="operator">-</span>runner

</pre>
<p>Qbs will use an empty profile when running tests which means it will try to autodetect toolchains, Qt versions and other things based on the system environment. It is possible to specify which profile should be used during the test-run by passing the <code>QBS_AUTOTEST_PROFILE</code> environment variable. This variable should be set prior to building Qbs itself; otherwise the <code>resolve</code> command should be used to update the environment stored in the buildgraph:</p>
<pre class="cpp">

  <span class="keyword">export</span> QBS_AUTOTEST_PROFILE<span class="operator">=</span>qt
  qbs resolve
  qbs build <span class="operator">-</span>p autotest<span class="operator">-</span>runner

</pre>
<p>It is also possible to set up a separate profile for a particular testsuite. A profile for the <code>tst_blackbox_android</code> suite can be set up as follows:</p>
<pre class="cpp">

  qbs setup<span class="operator">-</span>android pie
  <span class="keyword">export</span> QBS_AUTOTEST_PROFILE_BLACKBOX_ANDROID<span class="operator">=</span>pie

</pre>
<p>It might be useful to set up the directory with the Qbs settings to isolate the test environment:</p>
<pre class="cpp">

  <span class="keyword">export</span> QBS_AUTOTEST_SETTINGS_DIR<span class="operator">=</span><span class="operator">~</span><span class="operator">/</span>path<span class="operator">/</span>to<span class="operator">/</span>qbs<span class="operator">/</span>settings

</pre>
<a name="qbs-build-options"></a>
<h3 id="qbs-build-options">Qbs Build Options</h3>
<p>The <code>qbsbuildconfig</code> module can be used to customize the build. Properties of that module can be passed using command line as follows:</p>
<pre class="cpp">

  qbs build modules<span class="operator">.</span>qbsbuildconfig<span class="operator">.</span>enableAddressSanitizer:<span class="keyword">true</span>

</pre>
<p>Qbs recognizes the following properties:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Default value</th><th >Notes</th></tr></thead>
<tr valign="top" class="odd"><td >enableAddressSanitizer</td><td ><code>false</code></td><td >Whether to use address sanitizer or not. Enabling this option will add the -fsanitize=address flag.</td></tr>
<tr valign="top" class="even"><td >enableUnitTests</td><td ><code>false</code></td><td >Enable additional autotests. Enabling this option will export some symbols that would otherwise be private.</td></tr>
<tr valign="top" class="odd"><td >enableProjectFileUpdates</td><td ><code>false</code></td><td >Enable API for updating project files. This is required for an IDE and implies a dependency to the Qt GUI module that would not be needed for the Qbs command-line tool.</td></tr>
<tr valign="top" class="even"><td >enableRPath</td><td ><code>true</code></td><td >Use this property to disable the use of rpath. This can be used when packaging Qbs for distributions which do not permit the use of rpath, such as Fedora.</td></tr>
<tr valign="top" class="odd"><td >installApiHeaders</td><td ><code>true</code></td><td >Holds whether to install the header files for the Qbs libraries or not. This option is required to build against the Qbs libraries.</td></tr>
<tr valign="top" class="even"><td >enableBundledQt</td><td ><code>true</code></td><td >Holds whether the Qt libraries that Qbs depends on will be bundled with Qbs during the <code>install</code> step. This option is only implemented on <a href="nolink">macOS</a>.</td></tr>
<tr valign="top" class="odd"><td >useBundledQtScript</td><td ><code>false</code></td><td >Use the bundled QtScript module instead of the one shipped with Qt. In that case, QtScript should be checked out as a git submodule.</td></tr>
<tr valign="top" class="even"><td >libDirName</td><td ><code>&quot;lib&quot;</code></td><td >Directory name used by <code>libInstallDir</code> and <code>importLibInstallDir</code> properties.</td></tr>
<tr valign="top" class="odd"><td >appInstallDir</td><td ><code>&quot;bin&quot;</code></td><td >Relative directory path under the install prefix path to put application binaries.</td></tr>
<tr valign="top" class="even"><td >libInstallDir</td><td ><code>&quot;bin&quot;</code> on Windows, <code>libDirName</code> otherwise</td><td >Relative directory path under the install prefix path where to put shared libraries (excluding plugins, see the <code>relativePluginsPath</code> property).</td></tr>
<tr valign="top" class="odd"><td >importLibInstallDir</td><td ><code>libDirName</code></td><td >Relative directory path under the install prefix path where to put import libs.</td></tr>
<tr valign="top" class="even"><td >libexecInstallDir</td><td ><code>appInstallDir</code> on Windows, <code>&quot;libexec/qbs&quot;</code> otherwise</td><td >Relative directory path under the install prefix path where to put auxiliary binaries executed by the Qbs libraries.</td></tr>
<tr valign="top" class="odd"><td >systemSettingsDir</td><td ><code>undefined</code></td><td >Directory that will be used by Qbs to store its settings. If not specified, a default platform-dependent directory is used.</td></tr>
<tr valign="top" class="even"><td >installManPage</td><td ><code>true</code> on Unix, <code>false</code> otherwise</td><td >Whether to install man pages.</td></tr>
<tr valign="top" class="odd"><td >installHtml</td><td ><code>true</code></td><td >Whether to install HTML help pages.</td></tr>
<tr valign="top" class="even"><td >installQch</td><td ><code>false</code></td><td >Whether to install qch files. See <a href="https://doc.qt.io/qt-5/qthelp-framework.html">The Qt Help Framework</a> for details about qch files.</td></tr>
<tr valign="top" class="odd"><td >generatePkgConfigFiles</td><td >auto-detected</td><td >Whether to generate files for pkg-config.</td></tr>
<tr valign="top" class="even"><td >generateQbsModules</td><td >auto-detected</td><td >Whether to generate Qbs modules for the exported Qbs libraries. Use this when building another product against Qbs libraries using Qbs as build system.</td></tr>
<tr valign="top" class="odd"><td >docInstallDir</td><td ><code>&quot;share/doc/qbs/html&quot;</code></td><td >Relative directory path under the install prefix path where to put documentation.</td></tr>
<tr valign="top" class="even"><td >pkgConfigInstallDir</td><td ><code>libDirName</code> + <code>&quot;/pkgconfig&quot;</code></td><td >Relative directory path under the install prefix path where to put pkg-config files.</td></tr>
<tr valign="top" class="odd"><td >qbsModulesBaseDir</td><td ><code>libDirName</code> + <code>&quot;/qbs/modules&quot;</code></td><td >Relative directory path under the install prefix path where to put Qbs modules. Applies only when <code>generateQbsModules</code> is <code>true</code>.</td></tr>
<tr valign="top" class="even"><td >relativeLibexecPath</td><td ><code>&quot;../&quot;</code> + <code>libexecInstallDir</code></td><td >Path to the auxiliary binaries relative to the application binary.</td></tr>
<tr valign="top" class="odd"><td >relativePluginsPath</td><td ><code>&quot;../&quot;</code> + <code>libDirName</code></td><td >Path to plugin libraries relative to the application binary.</td></tr>
<tr valign="top" class="even"><td >relativeSearchPath</td><td ><code>&quot;..&quot;</code></td><td >Relative path to the directory where to look for Qbs development modules and items.</td></tr>
<tr valign="top" class="odd"><td >libRPaths</td><td >auto-detected</td><td >List of rpaths.</td></tr>
<tr valign="top" class="even"><td >resourcesInstallDir</td><td ><code>&quot;&quot;</code></td><td >Relative directory path under the install prefix path where to put shared resources like documentation, Qbs user modules and items.</td></tr>
<tr valign="top" class="odd"><td >pluginsInstallDir</td><td ><code>libDirName</code> + <code>&quot;/qbs/plugins&quot;</code></td><td >Relative path to the directory where to put plugins to.</td></tr>
</table></div>
<a name="using-docker"></a>
<h2 id="using-docker">Using Docker</h2>
<p>A set of Docker images for developing Qbs (which are maintained by the Qbs team) is available <a href="https://hub.docker.com/u/qbsbuild/">on Docker Hub</a>. Both Windows Server Core and Debian Linux container types are available.</p>
<p><b>Note: </b>The source code for the Qbs development Docker images is located in the <code>docker/</code> directory of the Qbs source tree, if you wish to build them yourself.</p><a name="linux-containers"></a>
<h3 id="linux-containers">Linux Containers</h3>
<p>The easiest way to get started is to build Qbs using a Linux container. These types of containers are supported out of the box on all the supported host platforms: Windows, <a href="nolink">macOS</a>, and Linux.</p>
<p>The images provide everything that is necessary to build and test Qbs:</p>
<ul>
<li>Qt SDK for building Qbs with <code>qmake</code></li>
<li>Latest stable release of Qbs for building Qbs with Qbs</li>
</ul>
<p>Run the following command to download the Qbs development image based on Debian 9 <i>Stretch</i>:</p>
<pre class="cpp">

  docker pull qbsbuild<span class="operator">/</span>qbsdev:stretch

</pre>
<p>You can then create a new container with the Qbs source directory mounted from your host machine's file system, by running:</p>
<pre class="cpp">

  docker run <span class="operator">-</span>it <span class="operator">-</span>v ${PWD}:<span class="operator">/</span>qbs <span class="operator">-</span>w <span class="operator">/</span>qbs qbsbuild<span class="operator">/</span>qbsdev:stretch

</pre>
<p>You will now be in an interactive Linux shell where you can develop and build Qbs.</p>
<p>For convenience, you can also run <code>docker-compose</code> from the project root directory:</p>
<pre class="cpp">

  docker<span class="operator">-</span>compose run <span class="operator">-</span><span class="operator">-</span>rm stretch

</pre>
<p>This will download and run the container in one go and mount the project root directory to <code>/qbs</code> in the container.</p>
<a name="windows-containers"></a>
<h3 id="windows-containers">Windows Containers</h3>
<p>To build Qbs for Windows using Windows containers, your host OS must be running Windows 10 Pro and have Hyper-V enabled. <a href="https://docs.docker.com/docker-for-windows/#switch-between-windows-and-linux-containers">Switch your Docker environment to use Windows containers</a>, then run the following command to download the Windows 10 Qbs development image:</p>
<pre class="cpp">

  docker pull qbsbuild<span class="operator">/</span>qbsdev:windowsservercore

</pre>
<p>You can then create a new container with the Qbs source directory mounted from your host machine's file system, by running:</p>
<pre class="cpp">

  docker run <span class="operator">-</span>it <span class="operator">-</span>v <span class="operator">%</span>CD<span class="operator">%</span>:C:\qbs <span class="operator">-</span>w C:\qbs qbsbuild<span class="operator">/</span>qbsdev:windowsservercore

</pre>
<p>If you want to use Windows containers on a <a href="nolink">macOS</a> or Linux host, you will have to create a virtual machine running Windows 10 and register it with <code>docker-machine</code>. There is at least <a href="https://github.com/StefanScherer/windows-docker-machine">one Open Source project</a> that helps to facilitate this by using using Packer, Vagrant, and VirtualBox.</p>
<p>The <code>docker run</code> command to spawn a Windows container on a Unix host will look slightly different (assuming <code>windows</code> is the name of the Docker machine associated with the Windows container hosting VM):</p>
<pre class="cpp">

  eval $(docker<span class="operator">-</span>machine env windows)
  docker run <span class="operator">-</span>it <span class="operator">-</span>v C:$PWD:C:\\qbs <span class="operator">-</span>w C:\\qbs qbsbuild<span class="operator">/</span>qbsdev:windowsservercore

</pre>
<a name="building-release-packages"></a>
<h3 id="building-release-packages">Building Release Packages</h3>
<p>Release packages for Qbs for Windows can be built using the following command on Windows:</p>
<pre class="cpp">

  docker run <span class="operator">-</span><span class="operator">-</span>rm <span class="operator">-</span>v <span class="operator">%</span>CD<span class="operator">%</span>:C:\qbs <span class="operator">-</span>w C:\qbs qbsbuild<span class="operator">/</span>qbsdev:windowsservercore cmd <span class="operator">/</span>c scripts\make<span class="operator">-</span>release<span class="operator">-</span>archives

</pre>
<p>For building release packages for Windows on <a href="nolink">macOS</a> or Linux:</p>
<pre class="cpp">

  eval $(docker<span class="operator">-</span>machine env windows)
  docker run <span class="operator">-</span><span class="operator">-</span>rm <span class="operator">-</span>v C:$PWD:C:\\qbs <span class="operator">-</span>w C:\\qbs qbsbuild<span class="operator">/</span>qbsdev:windowsservercore cmd <span class="operator">/</span>c scripts\\make<span class="operator">-</span>release<span class="operator">-</span>archives

</pre>
</div>
<!-- @@@building-qbs.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="reference.html">Reference</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="porting-to-qbs.html">Appendix B: Migrating from Other Build Systems</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
